#ifndef FILE_H
#define FILE_H

#include <QFile>
#include <QMutex>

class File : public QFile
{
    Q_OBJECT

public:
    explicit File(QObject *parent = 0);
    ~File();
    
public slots:
    qint64 write(const QByteArray &data);
    void close();

signals:
    void closed();

private:
    QMutex *m_mutex;
};

#endif // FILE_H
